
import * as $calcit from "./calcit.core.mjs";
import { dev_$q_ } from "./lilac.core.mjs";
import { number_ADD_ } from "./lilac.core.mjs";
import { optional_ADD_ } from "./lilac.core.mjs";
import { record_ADD_ } from "./lilac.core.mjs";
import { validate_lilac } from "./lilac.core.mjs";
var _tag={};
["all-optional?","check-keys?","elapse-loop","entries","formatted-message","gc","hit-times","last-hit-loop","loop","ok?","records","ref","trigger-loop","value",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function show_memory_usages() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('show-memory-usages', 0, arguments.length);
}
export function perform_gc_$x_(_$s_states) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('perform-gc!', 1, arguments.length);
let states_0 = $calcit.deref(_$s_states);
let gc = $calcit.get(states_0, _tag["gc"]);
$calcit.reset_$x_(_$s_removed_used, $calcit._$L_());
$calcit.reset_$x_(_$s_states, $calcit.update($calcit.deref(_$s_states), _tag["entries"], function f_PCT_(entries) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.map_kv(entries, function f_PCT_(f, entry) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);

if ($calcit.empty_$q_($calcit.get(entry, _tag["records"]))) { return null } else { return $calcit._$L_(f, $calcit.update(entry, _tag["records"], function f_PCT_(records) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.filter_not(records, function f_PCT_(p2) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
let params = $calcit.first(p2);
let record = $calcit.last(p2);

if ($calcit._$n__$e_(0, $calcit.get(record, _tag["hit-times"]))) { return true }
 else if ($calcit._GT_($calcit._SUB_($calcit.get(states_0, _tag["loop"]), $calcit.get(record, _tag["last-hit-loop"])), $calcit.get(gc, _tag["elapse-loop"]))) { $calcit.reset_$x_(_$s_removed_used, $calcit.conj($calcit.deref(_$s_removed_used), $calcit.get(record, _tag["hit-times"])));
( $calcit.deref(_$s_verbose_$q_) ? console.log($calcit.printable("[Memof verbose] removing record at loop", $calcit.get(states_0, _tag["loop"]), "--", f, params, $calcit.dissoc(record, _tag["value"]))) : null );
return true
 } else { return false }

}
)
}
)) }
}
)
}
));
( $calcit.not($calcit.empty_$q_($calcit.get(states_0, _tag["entries"]))) ? (function __fn__(){
console.log($calcit.printable($calcit.str("[Memof GC] Performed GC, entries from ", $calcit.count($calcit.get(states_0, _tag["entries"])), " to ", $calcit.count($calcit.get($calcit.deref(_$s_states), _tag["entries"])))));
console.log($calcit.printable(" Removed counts", $calcit.frequencies($calcit.deref(_$s_removed_used))))

})() : null );

if ($calcit.deref(_$s_verbose_$q_)) { return show_memory_usages() } else { return  null; }

}
export function new_loop_$x_(_$s_states) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('new-loop!', 1, arguments.length);
(function __fn__(){
( $calcit.not($calcit.string_$q_("expects atom for *states")) ? (function __fn__(){
let err_AUTO_1 = new Error($calcit.str_spaced("expects 1st argument to be string, got:", "expects atom for *states"));
 err_AUTO_1.data = null;
 throw err_AUTO_1;
})() : null );

if ($calcit._$e_(_tag["ref"], $calcit.type_of(_$s_states))) { return null } else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("="), _tag["ref"], new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("type-of"), new $calcit.CalcitSymbol("*states")])]))));
let err_AUTO_2 = new Error("expects atom for *states (= :ref (type-of *states))");
 err_AUTO_2.data = null;
 throw err_AUTO_2;
 }

})();
$calcit.reset_$x_(_$s_states, $calcit.update($calcit.deref(_$s_states), _tag["loop"], $calcit.inc));
let loop_count = $calcit.get($calcit.deref(_$s_states), _tag["loop"]);
let gc = $calcit.get($calcit.deref(_$s_states), _tag["gc"]);

if ($calcit._$e_(0, $calcit.invoke_method("rem",loop_count,$calcit.get(gc, _tag["trigger-loop"])))) { return perform_gc_$x_(_$s_states) } else { return  null; }

}
export function new_states(gc_options) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('new-states', 1, arguments.length);
( dev_$q_ ? (function __fn__(){
let result__1 = validate_lilac(gc_options, lilac_gc_options);

if ($calcit.not($calcit.get(result__1, _tag["ok?"]))) { console.log($calcit.printable($calcit.get(result__1, _tag["formatted-message"]), "\n", $calcit.str("(dev-check ", new $calcit.CalcitSymbol("gc-options"), " ", new $calcit.CalcitSymbol("lilac-gc-options"), "), where props is: ", gc_options))) } else { return  null; }

})() : null );
let options = $calcit.merge($calcit._$n__$M_(_tag["trigger-loop"], 100, _tag["elapse-loop"], 200), gc_options);
( $calcit.deref(_$s_verbose_$q_) ? (function __fn__(){
console.log($calcit.printable("Initialized caches with options:", options));
return show_memory_usages()

})() : null );
return $calcit._$n__$M_(_tag["loop"], 0, _tag["entries"], $calcit._$n__$M_(), _tag["gc"], options)

}
export function reset_entries_$x_(_$s_states) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('reset-entries!', 1, arguments.length);
console.log($calcit.printable("[Memof] reset."));
return $calcit.reset_$x_(_$s_states, $calcit.merge($calcit.deref(_$s_states), $calcit._$n__$M_(_tag["loop"], 0, _tag["entries"], $calcit._$n__$M_())))
}



export var _$s_removed_used = 
($calcit.peekDefatom("memof.core/*removed-used") ?? $calcit.defatom("memof.core/*removed-used", $calcit._$L_()))
;

export var _$s_verbose_$q_ = 
($calcit.peekDefatom("memof.core/*verbose?") ?? $calcit.defatom("memof.core/*verbose?", $calcit._$e_("true", $calcit.get_env("memofVerbose", "false"))))
;

export var lilac_gc_options = optional_ADD_(record_ADD_($calcit._$n__$M_(_tag["trigger-loop"], number_ADD_(), _tag["elapse-loop"], number_ADD_()), $calcit._$n__$M_(_tag["check-keys?"], true, _tag["all-optional?"], true)));

