
import * as $calcit from "./calcit.core.mjs";
import { check_keys } from "./lilac.util.mjs";
import { preview_data } from "./lilac.util.mjs";
import { seq_difference } from "./lilac.util.mjs";
import { seq_equal } from "./lilac.util.mjs";
var _tag={};
["all-optional?","and","any","args","bool","branches","check-keys?","check-size?","component","coord","custom","data","dict","enum","exact-keys?","fn","formatted-message","is","item","items","key-shape","lilac-type","list","max","message","min","name","next","nil","nonblank?","none","not","number","ok?","optional","options","or","pairs","pick-type","proto","re","record","rule","set","some","some?","string","symbol","tag","tuple","type-field",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export let format_message = function format_message(acc, result) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('format-message', 2, arguments.length);
  
  let times_AUTO_3 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_2 = null;
    if (times_AUTO_3 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit.nil_$q_(result)) { ret_AUTO_2 =acc } else { let message = $calcit.str($calcit.get(result, _tag["message"]), " at ", $calcit.filter_not($calcit.get(result, _tag["coord"]), $calcit.symbol_$q_));
ret_AUTO_2 =$calcit.recur($calcit.str(acc, ( $calcit.some_$q_(acc) ? "\n" : "" ), message), $calcit.get(result, _tag["next"]))
 }

    if (ret_AUTO_2 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_2.args.length !== 2) throw _calcit_args_mismatch('format-message', 2, ret_AUTO_2.args.length);
      [ acc, result ] = ret_AUTO_2.args;
      
      times_AUTO_3 += 1;
      continue;
    } else {
      return ret_AUTO_2;
    }
  }
}

export function validate_any(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-any', 3, arguments.length);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("number"));
let something_$q_ = (function __fn__(){
let v1__43 = $calcit.get(rule, _tag["some?"]);

if ($calcit.nil_$q_(v1__43)) { return false } else { return v1__43 }

})();

if (something_$q_) { 
if ($calcit.some_$q_(data)) { return ok_result } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__44 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__44)) { return $calcit.str("expects something, got ", preview_data(data)) } else { return v1__44 }

})()) } } else { return ok_result }

}
export function validate_bool(data, rule, coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-bool', 3, arguments.length);

if ($calcit.bool_$q_(data)) { return ok_result } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], $calcit.append(coord, new $calcit.CalcitSymbol("bool")), _tag["message"], (function __fn__(){
let v1__1 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__1)) { return $calcit.str("expects a bool, got ", preview_data(data)) } else { return v1__1 }

})()) }
}
export function validate_custom(data, rule, coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-custom', 3, arguments.length);
let method = $calcit.get(rule, _tag["fn"]);
let next_coord = $calcit.append(coord, new $calcit.CalcitSymbol("custom"));
let result = method(data, rule, coord);

if ($calcit.get(result, _tag["ok?"])) { return result } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], next_coord, _tag["message"], (function __fn__(){
let v1__36 = (function __fn__(){
let v1__37 = $calcit.get(result, _tag["message"]);

if ($calcit.nil_$q_(v1__37)) { return $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"])) } else { return v1__37 }

})();

if ($calcit.nil_$q_(v1__36)) { return "failed to validate with custom method" } else { return v1__36 }

})()) }

}
export function validate_enum(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-enum', 3, arguments.length);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("enum"));
let items = $calcit._$n_map_$o_get(rule, _tag["items"]);

if ($calcit.includes_$q_(items, data)) { return ok_result } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__45 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__45)) { return $calcit.str("expects value of ", $calcit.to_lispy_string(items), ", got ", preview_data(data)) } else { return v1__45 }

})()) }

}
export function validate_fn(data, rule, coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-fn', 3, arguments.length);
let next_coord = $calcit.append(coord, new $calcit.CalcitSymbol("fn"));

if ($calcit.fn_$q_(data)) { return ok_result } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], next_coord, _tag["message"], (function __fn__(){
let v1__7 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__7)) { return $calcit.str("expects a function, got ", preview_data(data)) } else { return v1__7 }

})()) }

}
export function validate_is(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-is', 3, arguments.length);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("is"));

if ($calcit._$e_(data, $calcit.get(rule, _tag["item"]))) { return ok_result } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__38 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__38)) { return $calcit.str("expects just ", preview_data($calcit.get(rule, _tag["item"])), ", got ", preview_data(data)) } else { return v1__38 }

})()) }

}
export function validate_nil(data, rule, coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-nil', 3, arguments.length);
let next_coord = $calcit.append(coord, new $calcit.CalcitSymbol("nil"));

if ($calcit.nil_$q_(data)) { return ok_result } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], next_coord, _tag["message"], (function __fn__(){
let v1__6 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__6)) { return $calcit.str("expects a nil, got ", preview_data(data)) } else { return v1__6 }

})()) }

}
export function validate_number(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-number', 3, arguments.length);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("number"));
let min_v = $calcit._$n_map_$o_get(rule, _tag["min"]);
let max_v = $calcit._$n_map_$o_get(rule, _tag["max"]);

if ($calcit.number_$q_(data)) { 
if (( ( $calcit.some_$q_(min_v) ? $calcit._GT__$e_(data, min_v) : true ) ? (function __fn__(){
let v1__10 = ( $calcit.some_$q_(max_v) ? $calcit._LT__$e_(data, max_v) : true );

if (v1__10) { return v1__10 } else { return false }

})() : false )) { return ok_result } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__11 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__11)) { return $calcit.str("expects number not in the range, got ", preview_data(data)) } else { return v1__11 }

})()) } } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__12 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__12)) { return $calcit.str("expects a number, got ", preview_data(data)) } else { return v1__12 }

})()) }

}
export function validate_string(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-string', 3, arguments.length);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("string"));
let re = $calcit._$n_map_$o_get(rule, _tag["re"]);
let nonblank_$q_ = (function __fn__(){
let v1__2 = $calcit.get(rule, _tag["nonblank?"]);

if ($calcit.nil_$q_(v1__2)) { return false } else { return v1__2 }

})();

if ($calcit.string_$q_(data)) { 
if ($calcit.some_$q_(re)) { console.error($calcit.printable("re-matches is not supported"))
 }
 else if ($calcit.some_$q_(nonblank_$q_)) { 
if (( nonblank_$q_ ? (function __fn__(){
let v1__3 = $calcit._$e_("", $calcit.trim(data));

if (v1__3) { return v1__3 } else { return false }

})() : false )) { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__4 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__4)) { return $calcit.str("expects nonblank string , got ", preview_data(data)) } else { return v1__4 }

})()) } else { return ok_result } } else { return ok_result } } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__5 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__5)) { return $calcit.str("expected a string, but got ", preview_data(data)) } else { return v1__5 }

})()) }

}
export function validate_symbol(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-symbol', 3, arguments.length);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("symbol"));

if ($calcit.symbol_$q_(data)) { return ok_result } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__9 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__9)) { return $calcit.str("expects a symbol, got ", preview_data(data)) } else { return v1__9 }

})()) }

}
export function validate_tag(data, rule, coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-tag', 3, arguments.length);
let next_coord = $calcit.append(coord, new $calcit.CalcitSymbol("tag"));

if ($calcit.tag_$q_(data)) { return ok_result } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], next_coord, _tag["message"], (function __fn__(){
let v1__8 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__8)) { return $calcit.str("expects a tag, got ", preview_data(data)) } else { return v1__8 }

})()) }

}
export function validate_tuple(data, rule, coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-tuple', 3, arguments.length);
let items = $calcit._$n_map_$o_get(rule, _tag["items"]);
let next_coord = $calcit.append(coord, new $calcit.CalcitSymbol("tuple"));
let check_size_$q_ = (function __fn__(){
let v1__39 = $calcit._$n_map_$o_get(rule, _tag["check-size?"]);

if ($calcit.nil_$q_(v1__39)) { return false } else { return v1__39 }

})();
let check_values = function f_PCT_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('f%', 0, arguments.length);
return $calcit.apply(function generated_loop(xs, ys, idx) {
  
if (arguments.length !== 3) throw _calcit_args_mismatch('generated-loop', 3, arguments.length);
  
  let times_AUTO_6 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_5 = null;
    if (times_AUTO_6 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit.empty_$q_(xs)) { 
if (check_size_$q_) { 
if (( $calcit.empty_$q_(ys) ? (function __fn__(){
let v1__40 = $calcit._$e_($calcit.count(items), $calcit.count(data));

if (v1__40) { return v1__40 } else { return false }

})() : false )) { ret_AUTO_5 =$calcit._$n__$M_(_tag["ok?"], true) } else { ret_AUTO_5 =$calcit._$n__$M_(_tag["ok?"], false, _tag["coord"], next_coord, _tag["rule"], rule, _tag["data"], ys, _tag["message"], (function __fn__(){
let v1__41 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__41)) { return $calcit.str("expects tuple of ", $calcit.count(items), " items, got ", $calcit.count(data)) } else { return v1__41 }

})()) } } else { ret_AUTO_5 =ok_result } } else { let r0 = $calcit.first(xs);
let y0 = $calcit.first(ys);
let child_coord = $calcit.append(next_coord, idx);
let result = validate_lilac(y0, r0, child_coord);

if ($calcit.get(result, _tag["ok?"])) { ret_AUTO_5 =$calcit.recur($calcit.rest(xs), $calcit.rest(ys), $calcit.inc(idx)) } else { ret_AUTO_5 =$calcit._$n__$M_(_tag["ok?"], false, _tag["coord"], next_coord, _tag["rule"], rule, _tag["data"], y0, _tag["message"], (function __fn__(){
let v1__42 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__42)) { return "failed validating in \"tuple\"" } else { return v1__42 }

})(), _tag["next"], result) }
 }

    if (ret_AUTO_5 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_5.args.length !== 3) throw _calcit_args_mismatch('generated-loop', 3, ret_AUTO_5.args.length);
      [ xs, ys, idx ] = ret_AUTO_5.args;
      
      times_AUTO_6 += 1;
      continue;
    } else {
      return ret_AUTO_5;
    }
  }
}

, $calcit._$L_(items, data, 0))
}
;

if ($calcit.list_$q_(data)) { return check_values() } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], $calcit.str("expects a vector for tuple, got ", preview_data(data))) }

}
export function validate_set(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-set', 3, arguments.length);
let item_rule = $calcit.get(rule, _tag["item"]);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("set"));

if ($calcit.set_$q_(data)) { return $calcit.apply(function generated_loop(xs, idx) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('generated-loop', 2, arguments.length);
  
  let times_AUTO_10 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_9 = null;
    if (times_AUTO_10 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    let v__29 = xs;
( $calcit.not($calcit.list_$q_(v__29)) ? (function __fn__(){
let err_AUTO_8 = new Error("expected a list in list-match");
 err_AUTO_8.data = null;
 throw err_AUTO_8;
})() : null );

if ($calcit.empty_$q_(v__29)) { ret_AUTO_9 =ok_result
 } else { let x0 = $calcit._$n_list_$o_nth(v__29, 0);
let xss = $calcit._$n_list_$o_slice(v__29, 1);
let child_coord = $calcit.append(coord, idx);
let result = validate_lilac(x0, item_rule, child_coord);

if ($calcit.get(result, _tag["ok?"])) { ret_AUTO_9 =$calcit.recur(xss, $calcit.inc(idx)) } else { ret_AUTO_9 =result }


 }


    if (ret_AUTO_9 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_9.args.length !== 2) throw _calcit_args_mismatch('generated-loop', 2, ret_AUTO_9.args.length);
      [ xs, idx ] = ret_AUTO_9.args;
      
      times_AUTO_10 += 1;
      continue;
    } else {
      return ret_AUTO_9;
    }
  }
}

, $calcit._$L_(data, 0)) } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__30 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__30)) { return $calcit.str("expects a set, got ", preview_data(data)) } else { return v1__30 }

})()) }

}
export function validate_record(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-record', 3, arguments.length);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("record"));
let pairs = $calcit._$n_map_$o_get(rule, _tag["pairs"]);
let exact_keys_$q_ = (function __fn__(){
let v1__13 = $calcit._$n_map_$o_get(rule, _tag["exact-keys?"]);

if ($calcit.nil_$q_(v1__13)) { return false } else { return v1__13 }

})();
let check_keys_$q_ = (function __fn__(){
let v1__14 = $calcit._$n_map_$o_get(rule, _tag["check-keys?"]);

if ($calcit.nil_$q_(v1__14)) { return false } else { return v1__14 }

})();
let all_optional_$q_ = (function __fn__(){
let v1__15 = $calcit._$n_map_$o_get(rule, _tag["all-optional?"]);

if ($calcit.nil_$q_(v1__15)) { return false } else { return v1__15 }

})();
let default_message = $calcit._$n_map_$o_get($calcit._$n_map_$o_get(rule, _tag["options"]), _tag["message"]);
let wanted_keys = $calcit.keys(pairs);
let existed_keys = ( (function __fn__(){
let v1__16 = $calcit.map_$q_(data);

if ($calcit.nil_$q_(v1__16)) { return $calcit.record_$q_(data) }
 else if ($calcit._$e_(false, v1__16)) { return $calcit.record_$q_(data) } else { return v1__16 }

})() ? $calcit.keys(data) : null );
let check_values = function f_PCT_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('f%', 0, arguments.length);
return $calcit.apply(function generated_loop(xs) {
  
if (arguments.length !== 1) throw _calcit_args_mismatch('generated-loop', 1, arguments.length);
  
  let times_AUTO_15 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_14 = null;
    if (times_AUTO_15 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    let v__18 = $calcit.destruct_set(xs);
( $calcit.not($calcit.tuple_$q_(v__18)) ? (function __fn__(){
let err_AUTO_12 = new Error($calcit.str("tag-match expected tuple, got", v__18));
 err_AUTO_12.data = null;
 throw err_AUTO_12;
})() : null );
let tag__17 = $calcit._$n_tuple_$o_nth($calcit.destruct_set(xs), 0);

if ($calcit._$n__$e_(tag__17, _tag["none"])) { ret_AUTO_14 =ok_result
 }
 else if ($calcit._$n__$e_(tag__17, _tag["some"])) { let x0 = $calcit._$n_tuple_$o_nth(v__18, 1);
let ys = $calcit._$n_tuple_$o_nth(v__18, 2);
let k0 = $calcit.first(x0);
let r0 = $calcit.last(x0);
let child_coord = $calcit.append(coord, k0);
let v = $calcit.get(data, k0);

if (( all_optional_$q_ ? (function __fn__(){
let v1__19 = $calcit.nil_$q_(v);

if (v1__19) { return v1__19 } else { return false }

})() : false )) { ret_AUTO_14 =$calcit.recur(ys) } else { let result = validate_lilac(v, r0, child_coord);

if ($calcit.get(result, _tag["ok?"])) { ret_AUTO_14 =$calcit.recur(ys) } else { ret_AUTO_14 =result }
 }
 } else { let err_AUTO_13 = new Error($calcit.str_spaced("tag-match found no matched case, missing `_` for", v__18));
 err_AUTO_13.data = null;
 throw err_AUTO_13; }



    if (ret_AUTO_14 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_14.args.length !== 1) throw _calcit_args_mismatch('generated-loop', 1, ret_AUTO_14.args.length);
      [ xs ] = ret_AUTO_14.args;
      
      times_AUTO_15 += 1;
      continue;
    } else {
      return ret_AUTO_14;
    }
  }
}

, $calcit._$L_($calcit.to_pairs(pairs)))
}
;

if ($calcit.not((function __fn__(){
let v1__20 = $calcit.map_$q_(data);

if ($calcit.nil_$q_(v1__20)) { 
if ($calcit.record_$q_(data)) { let v1__21 = ( $calcit.some_$q_($calcit.get(rule, _tag["proto"])) ? $calcit._$n_record_$o_matches_$q_($calcit.get(rule, _tag["proto"]), data) : true );

if (v1__21) { return v1__21 } else { return false }
 } else { return false } }
 else if ($calcit._$e_(false, v1__20)) { 
if ($calcit.record_$q_(data)) { let v1__22 = ( $calcit.some_$q_($calcit.get(rule, _tag["proto"])) ? $calcit._$n_record_$o_matches_$q_($calcit.get(rule, _tag["proto"]), data) : true );

if (v1__22) { return v1__22 } else { return false }
 } else { return false } } else { return v1__20 }

})())) { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__23 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__23)) { return $calcit.str("expects a record, got ", preview_data(data)) } else { return v1__23 }

})()) }
 else if (exact_keys_$q_) { 
if (seq_equal(existed_keys, wanted_keys)) { return check_values() } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], ( $calcit.nil_$q_(default_message) ? (function __fn__(){
let extra_keys = seq_difference(existed_keys, wanted_keys);
let missing_keys = seq_difference(wanted_keys, existed_keys);

if ($calcit.not($calcit.empty_$q_(extra_keys))) { return $calcit.str("unexpected record keys ", extra_keys, " for ", wanted_keys) } else { return $calcit.str("missing record keys ", missing_keys, " of ", wanted_keys) }

})() : default_message )) } }
 else if (check_keys_$q_) { let extra_keys = seq_difference(existed_keys, wanted_keys);

if ($calcit.empty_$q_(extra_keys)) { return check_values() } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], ( $calcit.nil_$q_(default_message) ? $calcit.str("unexpected record keys ", extra_keys, " for ", wanted_keys) : default_message )) }
 } else { return check_values() }

}
export function validate_pick_type(data, rule, coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-pick-type', 3, arguments.length);
let dict = $calcit.get(rule, _tag["dict"]);
let next_coord = $calcit.append(coord, new $calcit.CalcitSymbol("pick-type"));
let type_field = $calcit.get(rule, _tag["type-field"]);
let data_type = $calcit.get(data, type_field);

if ($calcit.nil_$q_($calcit.get(dict, data_type))) { return $calcit._$n__$M_(_tag["ok?"], false, _tag["coord"], next_coord, _tag["rule"], rule, _tag["data"], data, _tag["message"], (function __fn__(){
let v1__46 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__46)) { return $calcit.str("found no matched type in pick-type: ", data_type) } else { return v1__46 }

})()) } else { let next_rule = $calcit.get(dict, data_type);
let result = validate_lilac(data, next_rule, next_coord);

if ($calcit.get(result, _tag["ok?"])) { return result } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["coord"], next_coord, _tag["rule"], rule, _tag["data"], data, _tag["message"], (function __fn__(){
let v1__47 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__47)) { return $calcit.str("failed to match in pick-type") } else { return v1__47 }

})(), _tag["next"], result) }
 }

}
export function validate_or(data, rule, coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-or', 3, arguments.length);
let items = $calcit._$n_map_$o_get(rule, _tag["items"]);
let next_coord = $calcit.append(coord, new $calcit.CalcitSymbol("or"));
return function f_PCT_(xs, branches) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
  
  let times_AUTO_19 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_18 = null;
    if (times_AUTO_19 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    let v__32 = xs;
( $calcit.not($calcit.list_$q_(v__32)) ? (function __fn__(){
let err_AUTO_17 = new Error("expected a list in list-match");
 err_AUTO_17.data = null;
 throw err_AUTO_17;
})() : null );

if ($calcit.empty_$q_(v__32)) { ret_AUTO_18 =$calcit._$n__$M_(_tag["ok?"], false, _tag["coord"], next_coord, _tag["rule"], rule, _tag["data"], data, _tag["message"], (function __fn__(){
let v1__33 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__33)) { return "found no matched case in \"or\"" } else { return v1__33 }

})(), _tag["branches"], branches, _tag["next"], $calcit.last(branches))
 } else { let r0 = $calcit._$n_list_$o_nth(v__32, 0);
let rs = $calcit._$n_list_$o_slice(v__32, 1);
let result = validate_lilac(data, r0, next_coord);

if ($calcit._$n_map_$o_get(result, _tag["ok?"])) { ret_AUTO_18 =result } else { ret_AUTO_18 =$calcit.recur(rs, $calcit.append(branches, result)) }


 }


    if (ret_AUTO_18 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_18.args.length !== 2) throw _calcit_args_mismatch('f%', 2, ret_AUTO_18.args.length);
      [ xs, branches ] = ret_AUTO_18.args;
      
      times_AUTO_19 += 1;
      continue;
    } else {
      return ret_AUTO_18;
    }
  }
}

(items, $calcit._$L_())

}
export function validate_optional(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-optional', 3, arguments.length);
let item = $calcit._$n_map_$o_get(rule, _tag["item"]);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("optional"));

if ($calcit.nil_$q_(data)) { return ok_result } else { return validate_lilac(data, item, coord) }

}
export function validate_not(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-not', 3, arguments.length);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("not"));
let item = $calcit._$n_map_$o_get(rule, _tag["item"]);
let result = validate_lilac(data, item, coord);

if ($calcit._$n_map_$o_get(result, _tag["ok?"])) { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__31 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__31)) { return "expects a inverted value in \"not\"" } else { return v1__31 }

})(), _tag["next"], result) } else { return ok_result }

}
export function validate_list(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-list', 3, arguments.length);
let item_rule = $calcit._$n_map_$o_get(rule, _tag["item"]);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("list"));

if ($calcit.list_$q_(data)) { return function f_PCT_(xs, idx) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
  
  let times_AUTO_23 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_22 = null;
    if (times_AUTO_23 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    let v__27 = xs;
( $calcit.not($calcit.list_$q_(v__27)) ? (function __fn__(){
let err_AUTO_21 = new Error("expected a list in list-match");
 err_AUTO_21.data = null;
 throw err_AUTO_21;
})() : null );

if ($calcit.empty_$q_(v__27)) { ret_AUTO_22 =ok_result
 } else { let x0 = $calcit._$n_list_$o_nth(v__27, 0);
let xss = $calcit._$n_list_$o_slice(v__27, 1);
let child_coord = $calcit.append(coord, idx);
let result = validate_lilac(x0, item_rule, child_coord);

if ($calcit._$n_map_$o_get(result, _tag["ok?"])) { ret_AUTO_22 =$calcit.recur(xss, $calcit.inc(idx)) } else { ret_AUTO_22 =result }


 }


    if (ret_AUTO_22 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_22.args.length !== 2) throw _calcit_args_mismatch('f%', 2, ret_AUTO_22.args.length);
      [ xs, idx ] = ret_AUTO_22.args;
      
      times_AUTO_23 += 1;
      continue;
    } else {
      return ret_AUTO_22;
    }
  }
}

(data, 0) } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__28 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__28)) { return $calcit.str("expects a list, got ", preview_data(data)) } else { return v1__28 }

})()) }

}
export function validate_lilac(data, rule, arg) { 
if (arguments.length < 2) throw new Error('too few arguments');
if (arguments.length > 3) throw new Error('too many arguments');
let coord = ( $calcit.nil_$q_(arg) ? $calcit._$L_() : arg );
let kind = $calcit._$n_map_$o_get(rule, _tag["lilac-type"]);
let result = (function __fn__(){
let method = $calcit._$n_map_$o_get(core_methods, kind);

if ($calcit.some_$q_(method)) { return method(data, rule, coord)
 } else { let user_method = $calcit._$n_map_$o_get($calcit.deref(_$s_custom_methods), kind);

if ($calcit.some_$q_(user_method)) { return user_method(data, rule, coord)
 } else { console.log($calcit.printable("Unknown method:", kind, "of", rule));
return $calcit.quit_$x_(1)
 }
 }

})();

if ($calcit._$n_map_$o_get(result, _tag["ok?"])) { return result } else { return $calcit.assoc(result, _tag["formatted-message"], format_message("", result)) }

}
export function validate_dict(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-dict', 3, arguments.length);
let key_rule = $calcit._$n_map_$o_get(rule, _tag["key-shape"]);
let item_rule = $calcit._$n_map_$o_get(rule, _tag["item"]);
let coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("dict"));

if ($calcit.map_$q_(data)) { return function f_PCT_(xs) {
  
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
  
  let times_AUTO_28 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_27 = null;
    if (times_AUTO_28 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    let v__25 = $calcit.destruct_set(xs);
( $calcit.not($calcit.tuple_$q_(v__25)) ? (function __fn__(){
let err_AUTO_25 = new Error($calcit.str("tag-match expected tuple, got", v__25));
 err_AUTO_25.data = null;
 throw err_AUTO_25;
})() : null );
let tag__24 = $calcit._$n_tuple_$o_nth($calcit.destruct_set(xs), 0);

if ($calcit._$n__$e_(tag__24, _tag["none"])) { ret_AUTO_27 =ok_result
 }
 else if ($calcit._$n__$e_(tag__24, _tag["some"])) { let x0 = $calcit._$n_tuple_$o_nth(v__25, 1);
let ys = $calcit._$n_tuple_$o_nth(v__25, 2);
let k = $calcit.first(x0);
let v = $calcit.last(x0);
let child_coord = $calcit.append(coord, k);
let k_result = validate_lilac(k, key_rule, child_coord);
let result = validate_lilac(v, item_rule, child_coord);

if ($calcit._$n_map_$o_get(k_result, _tag["ok?"])) { 
if ($calcit._$n_map_$o_get(result, _tag["ok?"])) { ret_AUTO_27 =$calcit.recur(ys) } else { ret_AUTO_27 =result } } else { ret_AUTO_27 =k_result }
 } else { let err_AUTO_26 = new Error($calcit.str_spaced("tag-match found no matched case, missing `_` for", v__25));
 err_AUTO_26.data = null;
 throw err_AUTO_26; }



    if (ret_AUTO_27 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_27.args.length !== 1) throw _calcit_args_mismatch('f%', 1, ret_AUTO_27.args.length);
      [ xs ] = ret_AUTO_27.args;
      
      times_AUTO_28 += 1;
      continue;
    } else {
      return ret_AUTO_27;
    }
  }
}

($calcit.to_pairs(data)) } else { return $calcit._$n__$M_(_tag["ok?"], false, _tag["data"], data, _tag["rule"], rule, _tag["coord"], coord, _tag["message"], (function __fn__(){
let v1__26 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__26)) { return $calcit.str("expects a dict, got ", preview_data(data)) } else { return v1__26 }

})()) }

}
export function validate_component(data, rule, coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-component', 3, arguments.length);
let lazy_fn = $calcit._$n_map_$o_get(rule, _tag["fn"]);
let next_coord = $calcit.append(coord, $calcit.turn_symbol($calcit.get(rule, _tag["name"])));
let next_rule = lazy_fn(...$calcit.listToArray($calcit._$n_map_$o_get(rule, _tag["args"])));
return validate_lilac(data, next_rule, next_coord)

}
export function validate_and(data, rule, base_coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('validate-and', 3, arguments.length);
let items = $calcit._$n_map_$o_get(rule, _tag["items"]);
let next_coord = $calcit.append(base_coord, new $calcit.CalcitSymbol("and"));
return function f_PCT_(xs) {
  
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
  
  let times_AUTO_32 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_31 = null;
    if (times_AUTO_32 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    let v__34 = xs;
( $calcit.not($calcit.list_$q_(v__34)) ? (function __fn__(){
let err_AUTO_30 = new Error("expected a list in list-match");
 err_AUTO_30.data = null;
 throw err_AUTO_30;
})() : null );

if ($calcit.empty_$q_(v__34)) { ret_AUTO_31 =ok_result
 } else { let r0 = $calcit._$n_list_$o_nth(v__34, 0);
let rs = $calcit._$n_list_$o_slice(v__34, 1);
let result = validate_lilac(data, r0, next_coord);

if ($calcit._$n_map_$o_get(result, _tag["ok?"])) { ret_AUTO_31 =$calcit.recur(rs) } else { ret_AUTO_31 =$calcit._$n__$M_(_tag["ok?"], false, _tag["coord"], next_coord, _tag["rule"], rule, _tag["data"], data, _tag["message"], (function __fn__(){
let v1__35 = $calcit.get_in(rule, $calcit._$L_(_tag["options"], _tag["message"]));

if ($calcit.nil_$q_(v1__35)) { return "failed validating in \"and\"" } else { return v1__35 }

})(), _tag["next"], result) }


 }


    if (ret_AUTO_31 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_31.args.length !== 1) throw _calcit_args_mismatch('f%', 1, ret_AUTO_31.args.length);
      [ xs ] = ret_AUTO_31.args;
      
      times_AUTO_32 += 1;
      continue;
    } else {
      return ret_AUTO_31;
    }
  }
}

(items)

}
export function number_ADD_(arg) { 
if (arguments.length < 0) throw new Error('too few arguments');
if (arguments.length > 1) throw new Error('too many arguments');
let options = ( $calcit.nil_$q_(arg) ? $calcit._$n__$M_() : arg );
check_keys("checking number+", options, $calcit._$L_(_tag["max"], _tag["min"]));
return $calcit._$n__$M_(_tag["lilac-type"], _tag["number"], _tag["max"], $calcit.get(options, _tag["max"]), _tag["min"], $calcit.get(options, _tag["min"]), _tag["options"], options)

}
export function optional_ADD_(item, arg) { 
if (arguments.length < 1) throw new Error('too few arguments');
if (arguments.length > 2) throw new Error('too many arguments');
let options = ( $calcit.nil_$q_(arg) ? $calcit._$n__$M_() : arg );
return $calcit._$n__$M_(_tag["lilac-type"], _tag["optional"], _tag["item"], item, _tag["options"], options)

}
export function record_ADD_(pairs, arg) { 
if (arguments.length < 1) throw new Error('too few arguments');
if (arguments.length > 2) throw new Error('too many arguments');
let options = ( $calcit.nil_$q_(arg) ? $calcit._$n__$M_() : arg );
check_keys("checking record+", options, $calcit._$L_(_tag["exact-keys?"], _tag["check-keys?"], _tag["all-optional?"], _tag["proto"]));
return $calcit._$n__$M_(_tag["lilac-type"], _tag["record"], _tag["pairs"], pairs, _tag["options"], options, _tag["exact-keys?"], (function __fn__(){
let v1__48 = $calcit.get(options, _tag["exact-keys?"]);

if ($calcit.nil_$q_(v1__48)) { return false } else { return v1__48 }

})(), _tag["check-keys?"], (function __fn__(){
let v1__49 = $calcit.get(options, _tag["check-keys?"]);

if ($calcit.nil_$q_(v1__49)) { return false } else { return v1__49 }

})(), _tag["all-optional?"], (function __fn__(){
let v1__50 = $calcit.get(options, _tag["all-optional?"]);

if ($calcit.nil_$q_(v1__50)) { return false } else { return v1__50 }

})(), _tag["proto"], $calcit.get(options, _tag["proto"]))

}



export var _$s_custom_methods = 
($calcit.peekDefatom("lilac.core/*custom-methods") ?? $calcit.defatom("lilac.core/*custom-methods", $calcit._$n__$M_()))
;

export var ok_result = $calcit._$n__$M_(_tag["ok?"], true);

export var core_methods = $calcit._$n__$M_(_tag["bool"], validate_bool, _tag["string"], validate_string, _tag["nil"], validate_nil, _tag["fn"], validate_fn, _tag["tag"], validate_tag, _tag["symbol"], validate_symbol, _tag["number"], validate_number, _tag["record"], validate_record, _tag["dict"], validate_dict, _tag["list"], validate_list, _tag["set"], validate_set, _tag["not"], validate_not, _tag["or"], validate_or, _tag["and"], validate_and, _tag["custom"], validate_custom, _tag["component"], validate_component, _tag["is"], validate_is, _tag["optional"], validate_optional, _tag["tuple"], validate_tuple, _tag["any"], validate_any, _tag["enum"], validate_enum, _tag["pick-type"], validate_pick_type);

export var dev_$q_ = $calcit._$e_("dev", $calcit.get_env("mode", "release"));

