
import * as $calcit from "./calcit.core.mjs";
import { vec_add } from "./recollect.util.mjs";
var _tag={};
["assoc","map-splice","pick","pick-in","replace","set-splice","update","update-in","vec-append","vec-drop",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function patch_map(base, removed, added) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('patch-map', 3, arguments.length);
return $calcit.merge($calcit.unselect_keys(base, removed), added)
}
export function patch_map_set(base, k, data) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('patch-map-set', 3, arguments.length);
return $calcit.assoc(base, k, data)
}
export function patch_set(base, removed, added) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('patch-set', 3, arguments.length);
return $calcit.union($calcit.difference(base, removed), added)
}
export function patch_vector_append(base, data) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('patch-vector-append', 2, arguments.length);
return vec_add(base, data)
}
export function patch_vector_drop(base, data) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('patch-vector-drop', 2, arguments.length);
return $calcit.slice(base, 0, data)
}
export let patch_twig = function patch_twig(base, changes) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('patch-twig', 2, arguments.length);
  
  let times_AUTO_4 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_3 = null;
    if (times_AUTO_4 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    let v__1 = changes;
( $calcit.not($calcit.list_$q_(v__1)) ? (function __fn__(){
let err_AUTO_2 = new Error("expected a list in list-match");
 err_AUTO_2.data = null;
 throw err_AUTO_2;
})() : null );

if ($calcit.empty_$q_(v__1)) { ret_AUTO_3 =base
 } else { let c0 = $calcit._$n_list_$o_nth(v__1, 0);
let cs = $calcit._$n_list_$o_slice(v__1, 1);
ret_AUTO_3 =$calcit.recur(patch_one(base, c0), cs)

 }


    if (ret_AUTO_3 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_3.args.length !== 2) throw _calcit_args_mismatch('patch-twig', 2, ret_AUTO_3.args.length);
      [ base, changes ] = ret_AUTO_3.args;
      
      times_AUTO_4 += 1;
      continue;
    } else {
      return ret_AUTO_3;
    }
  }
}

export function patch_one(base, change) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('patch-one', 2, arguments.length);
( $calcit.not($calcit.tuple_$q_(change)) ? (function __fn__(){
let err_AUTO_5 = new Error($calcit.str("tag-match expected tuple, got", change));
 err_AUTO_5.data = null;
 throw err_AUTO_5;
})() : null );
let tag__2 = $calcit._$n_tuple_$o_nth(change, 0);

if ($calcit._$n__$e_(tag__2, _tag["replace"])) { let data = $calcit._$n_tuple_$o_nth(change, 1);
return data
 }
 else if ($calcit._$n__$e_(tag__2, _tag["vec-append"])) { let data = $calcit._$n_tuple_$o_nth(change, 1);
return patch_vector_append(base, data)
 }
 else if ($calcit._$n__$e_(tag__2, _tag["vec-drop"])) { let data = $calcit._$n_tuple_$o_nth(change, 1);
return patch_vector_drop(base, data)
 }
 else if ($calcit._$n__$e_(tag__2, _tag["assoc"])) { let k = $calcit._$n_tuple_$o_nth(change, 1);
let data = $calcit._$n_tuple_$o_nth(change, 2);
return patch_map_set(base, k, data)
 }
 else if ($calcit._$n__$e_(tag__2, _tag["set-splice"])) { let removed = $calcit._$n_tuple_$o_nth(change, 1);
let added = $calcit._$n_tuple_$o_nth(change, 2);
return patch_set(base, removed, added)
 }
 else if ($calcit._$n__$e_(tag__2, _tag["map-splice"])) { let removed = $calcit._$n_tuple_$o_nth(change, 1);
let added = $calcit._$n_tuple_$o_nth(change, 2);
return patch_map(base, removed, added)
 }
 else if ($calcit._$n__$e_(tag__2, _tag["update"])) { let k = $calcit._$n_tuple_$o_nth(change, 1);
let c0 = $calcit._$n_tuple_$o_nth(change, 2);
return $calcit.update(base, k, function f_PCT_(o) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return patch_one(o, c0)
}
)
 }
 else if ($calcit._$n__$e_(tag__2, _tag["update-in"])) { let ks = $calcit._$n_tuple_$o_nth(change, 1);
let c0 = $calcit._$n_tuple_$o_nth(change, 2);
return $calcit.update_in(base, ks, function f_PCT_(o) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return patch_one(o, c0)
}
)
 }
 else if ($calcit._$n__$e_(tag__2, _tag["pick"])) { let k = $calcit._$n_tuple_$o_nth(change, 1);
let changes = $calcit._$n_tuple_$o_nth(change, 2);
return $calcit.update(base, k, function f_PCT_(o) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return patch_twig(o, changes)
}
)
 }
 else if ($calcit._$n__$e_(tag__2, _tag["pick-in"])) { let ks = $calcit._$n_tuple_$o_nth(change, 1);
let changes = $calcit._$n_tuple_$o_nth(change, 2);
return $calcit.update_in(base, ks, function f_PCT_(o) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return patch_twig(o, changes)
}
)
 } else { console.error($calcit.printable("Unkown op:", change));
return base
 }


}



