
import * as $calcit from "./calcit.core.mjs";
var _tag={};
["align-items","auto","background-color","border","border-radius","center","color","cursor","display","flex","flex-direction","flex-start","font-family","font-size","height","inline-block","justify-content","left","line-height","margin","min-width","no-select","none","outline","overflow","padding","pointer","position","row","text-align","text-decoration","top","transition-duration","underline","user-select","vertical-align","white","width",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function hsl(h, s, l, a) { 
if (arguments.length < 3) throw new Error('too few arguments');
if (arguments.length > 4) throw new Error('too many arguments');

if ($calcit.some_$q_(a)) { return $calcit.str("hsl(", h, ",", s, "%,", l, "%,", a, ")") } else { return $calcit.str("hsl(", h, ",", s, "%,", l, "%)") }
}



export var button = $calcit._$n__$M_(_tag["min-width"], "80px", _tag["line-height"], "24px", _tag["border-radius"], "4px", _tag["font-size"], 14, _tag["text-align"], "center", _tag["border"], $calcit.str("1px solid ", hsl(220, 100, 76)), _tag["color"], hsl(220, 100, 76), _tag["cursor"], "pointer", _tag["display"], "inline-block", _tag["padding"], "0 8px", _tag["outline"], _tag["none"], _tag["vertical-align"], _tag["top"], _tag["background-color"], _tag["white"], _tag["user-select"], _tag["none"], _tag["transition-duration"], "300ms");

export var center = $calcit._$n__$M_(_tag["display"], "flex", _tag["flex-direction"], "column", _tag["justify-content"], "center", _tag["align-items"], "center");

export var column = $calcit._$n__$M_(_tag["display"], "flex", _tag["align-items"], "stretch", _tag["flex-direction"], "column");

export var column_dispersive = $calcit._$n__$M_(_tag["display"], "flex", _tag["align-items"], "center", _tag["justify-content"], "space-around", _tag["flex-direction"], "column");

export var default_fonts = "Hind,Verdana,'Hiragino Sans GB','WenQuanYi Micro Hei','Microsoft Yahei',sans-serif";

export var flex = $calcit._$n__$M_(_tag["flex"], 1);

export var font_code = "Source Code Pro, Menlo, Ubuntu Mono, Consolas, monospace";

export var font_fancy = "Josefin Sans, Helvetica neue, Arial, sans-serif";

export var font_normal = "Hind, Helvatica, Arial, sans-serif";

export var fullscreen = $calcit._$n__$M_(_tag["position"], "absolute", _tag["left"], 0, _tag["top"], 0, _tag["width"], "100%", _tag["height"], "100%", _tag["overflow"], _tag["auto"]);

export var global = $calcit._$n__$M_(_tag["line-height"], "2", _tag["font-size"], "14px", _tag["font-family"], default_fonts, _tag["color"], hsl(0, 0, 20));

export var input = $calcit.merge(global, $calcit._$n__$M_(_tag["border"], "none", _tag["outline"], "none", _tag["border"], $calcit.str("1px solid ", hsl(0, 0, 80)), _tag["border-radius"], "4px", _tag["font-size"], "14px", _tag["padding"], "4px 8px", _tag["min-width"], "120px", _tag["line-height"], "16px", _tag["height"], 28, _tag["font-family"], default_fonts, _tag["vertical-align"], _tag["top"]));

export var link = $calcit._$n__$M_(_tag["text-decoration"], _tag["underline"], _tag["user-select"], _tag["no-select"], _tag["height"], 24, _tag["line-height"], "24px", _tag["margin"], 4, _tag["display"], _tag["inline-block"], _tag["cursor"], _tag["pointer"], _tag["user-select"], _tag["none"], _tag["color"], hsl(200, 100, 76));

export var row = $calcit._$n__$M_(_tag["display"], "flex", _tag["align-items"], "stretch", _tag["flex-direction"], "row");

export var row_center = $calcit._$n__$M_(_tag["display"], "flex", _tag["align-items"], "center", _tag["justify-content"], "center", _tag["flex-direction"], "row");

export var row_middle = $calcit._$n__$M_(_tag["display"], _tag["flex"], _tag["align-items"], _tag["center"], _tag["justify-content"], _tag["flex-start"], _tag["flex-direction"], _tag["row"]);

export var row_parted = $calcit._$n__$M_(_tag["display"], "flex", _tag["align-items"], "center", _tag["justify-content"], "space-between", _tag["flex-direction"], "row");

