
import * as $calcit from "./calcit.core.mjs";
import { activate_instance_$x_ } from "./respo.controller.client.mjs";
import { build_deliver_event } from "./respo.controller.resolve.mjs";
import { collect_mounting } from "./respo.render.effect.mjs";
import { component_$q_ } from "./respo.util.detect.mjs";
import { effect_$q_ } from "./respo.util.detect.mjs";
import { element_$q_ } from "./respo.util.detect.mjs";
import { find_element_diffs } from "./respo.render.diff.mjs";
import { patch_instance_$x_ } from "./respo.controller.client.mjs";
import { pick_attrs } from "./respo.util.list.mjs";
import { pick_event } from "./respo.util.list.mjs";
import { reset_calling_caches_$x_ } from "./memof.alias.mjs";
import { reset_memof1_caches_$x_ } from "./memof.once.mjs";
import * as $respo_DOT_schema from "./respo.schema.mjs";
import { tick_calling_loop_$x_ } from "./memof.alias.mjs";
import { val_exists_$q_ } from "./respo.util.list.mjs";
var _tag={};
["a","attrs","button","children","class-name","coord","cursor","div","effects","event","inner-text","input","name","pre","span","style","tree",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function confirm_child(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('confirm-child', 1, arguments.length);
(function __fn__(){
( $calcit.not($calcit.string_$q_("Invalid data in elements tree: ")) ? (function __fn__(){
let err_AUTO_1 = new Error($calcit.str_spaced("expects 1st argument to be string, got:", "Invalid data in elements tree: "));
 err_AUTO_1.data = null;
 throw err_AUTO_1;
})() : null );

if ((function __fn__(){
let v1__2 = $calcit.nil_$q_(x);

if ($calcit.nil_$q_(v1__2)) { let v1__3 = element_$q_(x);

if ($calcit.nil_$q_(v1__3)) { return component_$q_(x) }
 else if ($calcit._$e_(false, v1__3)) { return component_$q_(x) } else { return v1__3 }
 }
 else if ($calcit._$e_(false, v1__2)) { let v1__4 = element_$q_(x);

if ($calcit.nil_$q_(v1__4)) { return component_$q_(x) }
 else if ($calcit._$e_(false, v1__4)) { return component_$q_(x) } else { return v1__4 }
 } else { return v1__2 }

})()) { return null } else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("or"), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("nil?"), new $calcit.CalcitSymbol("x")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("element?"), new $calcit.CalcitSymbol("x")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("component?"), new $calcit.CalcitSymbol("x")])]))));
let err_AUTO_2 = new Error("Invalid data in elements tree:  (or (nil? x) (element? x) (component? x))");
 err_AUTO_2.data = null;
 throw err_AUTO_2;
 }

})();
return x
}
export function create_element(tag_name, props, ...children) { 
if (arguments.length < 2) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
let attrs = pick_attrs(props);
let styles = $calcit.sort($calcit.invoke_method("to-list",(function __fn__(){
let v1__1 = $calcit.get(props, _tag["style"]);

if ($calcit.nil_$q_(v1__1)) { return $calcit._$n__$M_() } else { return v1__1 }

})(),), function f_PCT_(x, y) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit._$n_compare($calcit.first(x), $calcit.first(y))
}
);
let event = pick_event(props);
let children_nodes = $calcit.filter($calcit.map_indexed(children, function f_PCT_(idx, item) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
confirm_child(item);
return $calcit._$L_(idx, item)
}
), val_exists_$q_);
return $calcit._$n__PCT__$M_($respo_DOT_schema.Element, _tag["name"], tag_name, _tag["coord"], null, _tag["attrs"], attrs, _tag["style"], styles, _tag["event"], event, _tag["children"], children_nodes)

}
export function span(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_tag["span"], props, ...$calcit.listToArray(children))
}
export function _LT__GT_(content, style) { 
if (arguments.length < 1) throw new Error('too few arguments');
if (arguments.length > 2) throw new Error('too many arguments');

if ($calcit.string_$q_(style)) { return span($calcit._$n__$M_(_tag["inner-text"], content, _tag["class-name"], style)) } else { return span($calcit._$n__$M_(_tag["inner-text"], content, _tag["style"], style)) }
}
export function _GT__GT_(states, k) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('>>', 2, arguments.length);
let parent_cursor = (function __fn__(){
let v1__14 = $calcit.get(states, _tag["cursor"]);

if ($calcit.nil_$q_(v1__14)) { return $calcit._$L_() } else { return v1__14 }

})();
let branch = (function __fn__(){
let v1__15 = $calcit.get(states, k);

if ($calcit.nil_$q_(v1__15)) { return $calcit._$n__$M_() } else { return v1__15 }

})();
return $calcit.assoc(branch, _tag["cursor"], $calcit.conj(parent_cursor, k))

}
export function a(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_tag["a"], props, ...$calcit.listToArray(children))
}
export function button(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_tag["button"], props, ...$calcit.listToArray($calcit.map(children, confirm_child)))
}
export function clear_cache_$x_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('clear-cache!', 0, arguments.length);
reset_calling_caches_$x_();
return reset_memof1_caches_$x_()
}
export function confirm_child_pair(pair) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('confirm-child-pair', 1, arguments.length);
(function __fn__(){
( $calcit.not($calcit.string_$q_("expected pair")) ? (function __fn__(){
let err_AUTO_3 = new Error($calcit.str_spaced("expects 1st argument to be string, got:", "expected pair"));
 err_AUTO_3.data = null;
 throw err_AUTO_3;
})() : null );

if (( $calcit.list_$q_(pair) ? (function __fn__(){
let v1__8 = $calcit._$n__$e_(2, $calcit.count(pair));

if (v1__8) { return v1__8 } else { return false }

})() : false )) { return null } else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("and"), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("list?"), new $calcit.CalcitSymbol("pair")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("&="), 2, new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("count"), new $calcit.CalcitSymbol("pair")])])]))));
let err_AUTO_4 = new Error("expected pair (and (list? pair) (&= 2 (count pair)))");
 err_AUTO_4.data = null;
 throw err_AUTO_4;
 }

})();
(function __fn__(){
let x = $calcit.nth(pair, 1);
( $calcit.not($calcit.string_$q_("Invalid data in elements tree: ")) ? (function __fn__(){
let err_AUTO_5 = new Error($calcit.str_spaced("expects 1st argument to be string, got:", "Invalid data in elements tree: "));
 err_AUTO_5.data = null;
 throw err_AUTO_5;
})() : null );

if ((function __fn__(){
let v1__9 = $calcit.nil_$q_(x);

if ($calcit.nil_$q_(v1__9)) { let v1__10 = element_$q_(x);

if ($calcit.nil_$q_(v1__10)) { return component_$q_(x) }
 else if ($calcit._$e_(false, v1__10)) { return component_$q_(x) } else { return v1__10 }
 }
 else if ($calcit._$e_(false, v1__9)) { let v1__11 = element_$q_(x);

if ($calcit.nil_$q_(v1__11)) { return component_$q_(x) }
 else if ($calcit._$e_(false, v1__11)) { return component_$q_(x) } else { return v1__11 }
 } else { return v1__9 }

})()) { return null } else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("or"), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("nil?"), new $calcit.CalcitSymbol("x")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("element?"), new $calcit.CalcitSymbol("x")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("component?"), new $calcit.CalcitSymbol("x")])]))));
let err_AUTO_6 = new Error("Invalid data in elements tree:  (or (nil? x) (element? x) (component? x))");
 err_AUTO_6.data = null;
 throw err_AUTO_6;
 }


})();
return pair
}
export function create_list_element(tag_name, props, child_map) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('create-list-element', 3, arguments.length);
let attrs = pick_attrs(props);
let styles = $calcit.sort($calcit.invoke_method("to-list",(function __fn__(){
let v1__7 = $calcit.get(props, _tag["style"]);

if ($calcit.nil_$q_(v1__7)) { return $calcit._$n__$M_() } else { return v1__7 }

})(),), function f_PCT_(x, y) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit._$n_compare($calcit.first(x), $calcit.first(y))
}
);
let event = pick_event(props);
return $calcit._$n__PCT__$M_($respo_DOT_schema.Element, _tag["name"], tag_name, _tag["coord"], null, _tag["attrs"], attrs, _tag["style"], styles, _tag["event"], event, _tag["children"], $calcit.map(child_map, confirm_child_pair))

}
export function div(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_tag["div"], props, ...$calcit.listToArray(children))
}
export function extract_effects_list(markup) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('extract-effects-list', 1, arguments.length);
let markup_tree = $calcit.get(markup, _tag["tree"]);

if ($calcit.nil_$q_(markup_tree)) { return $calcit.assoc(markup, _tag["tree"], span(null)) }
 else if ($calcit.list_$q_(markup_tree)) { let node_tree = $calcit.find(markup_tree, function f_PCT_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);

if ($calcit.record_$q_(x)) { let v1__5 = (function __fn__(){
let v1__6 = component_$q_(x);

if ($calcit.nil_$q_(v1__6)) { return element_$q_(x) }
 else if ($calcit._$e_(false, v1__6)) { return element_$q_(x) } else { return v1__6 }

})();

if (v1__5) { return v1__5 } else { return false }
 } else { return false }
}
);
let effects_list = $calcit.filter(markup_tree, effect_$q_);
return $calcit.assoc($calcit.assoc(markup, _tag["tree"], node_tree), _tag["effects"], effects_list)
 } else { return markup }

}
export function input(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_tag["input"], props, ...$calcit.listToArray(children))
}
export function list__GT_(props, children) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('list->', 2, arguments.length);
return create_list_element(_tag["div"], props, children)
}
export function mount_app_$x_(target, element, _$s_dispatch_fn) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('mount-app!', 3, arguments.length);
let deliver_event = build_deliver_event(_$s_global_element, _$s_dispatch_fn);
let _$s_changes = $calcit.atom($calcit._$L_());
let collect_$x_ = function f_PCT_(op) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.reset_$x_(_$s_changes, $calcit.conj($calcit.deref(_$s_changes), op))
}
;
activate_instance_$x_(element, target, deliver_event);
collect_mounting(collect_$x_, $calcit._$L_(), $calcit._$L_(), element, true);
patch_instance_$x_($calcit.deref(_$s_changes), target, deliver_event);
return $calcit.reset_$x_(_$s_global_element, element)

}
export function pre(props, ...children) { 
if (arguments.length < 1) throw new Error('too few arguments');
children = $calcit.arrayToList(children);
return create_element(_tag["pre"], props, ...$calcit.listToArray(children))
}
export function rerender_app_$x_(target, element, _$s_dispatch_fn) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('rerender-app!', 3, arguments.length);
tick_calling_loop_$x_();
let deliver_event = build_deliver_event(_$s_global_element, _$s_dispatch_fn);
let _$s_changes = $calcit.atom($calcit._$L_());
let collect_$x_ = function f_PCT_(op) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.reset_$x_(_$s_changes, $calcit.conj($calcit.deref(_$s_changes), op))
}
;
find_element_diffs(collect_$x_, $calcit._$L_(), $calcit._$L_(), $calcit.deref(_$s_global_element), element);
(function __fn__(){
let logger = $calcit.deref(_$s_changes_logger);

if ($calcit.some_$q_(logger)) { return logger($calcit.deref(_$s_global_element), element, $calcit.deref(_$s_changes)) } else { return null }

})();
patch_instance_$x_($calcit.deref(_$s_changes), target, deliver_event);
return $calcit.reset_$x_(_$s_global_element, element)

}
export function render_$x_(target, markup, dispatch_$x_) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('render!', 3, arguments.length);
$calcit.reset_$x_(_$s_dispatch_fn, dispatch_$x_);

if ($calcit.some_$q_($calcit.deref(_$s_global_element))) { return rerender_app_$x_(target, markup, _$s_dispatch_fn) } else { return mount_app_$x_(target, markup, _$s_dispatch_fn) }
}



export var _$s_changes_logger = 
($calcit.peekDefatom("respo.core/*changes-logger") ?? $calcit.defatom("respo.core/*changes-logger", null))
;

export var _$s_dispatch_fn = 
($calcit.peekDefatom("respo.core/*dispatch-fn") ?? $calcit.defatom("respo.core/*dispatch-fn", null))
;

export var _$s_global_element = 
($calcit.peekDefatom("respo.core/*global-element") ?? $calcit.defatom("respo.core/*global-element", null))
;

