
import * as $calcit from "./calcit.core.mjs";
import { collect_mounting } from "./respo.render.effect.mjs";
import { collect_unmounting } from "./respo.render.effect.mjs";
import { collect_updating } from "./respo.render.effect.mjs";
import { component_$q_ } from "./respo.util.detect.mjs";
import { dev_$q_ } from "./respo.schema.mjs";
import { element_$q_ } from "./respo.util.detect.mjs";
import { val_of_first } from "./respo.util.list.mjs";
var _tag={};
["add-element","add-prop","add-style","append-element","attrs","before-update","children","event","name","replace-element","replace-prop","replace-style","rm-element","rm-event","rm-prop","rm-style","set-event","style","tree","update",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function detect_keys_dup(child_keys) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('detect-keys-dup', 1, arguments.length);
let size = $calcit.count(child_keys);
let last_pos = $calcit.dec(size);

if ($calcit._GT_(size, 1)) { return function f_PCT_(p, q) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
  
  let times_AUTO_3 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_2 = null;
    if (times_AUTO_3 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit._$n__$e_($calcit.nth(child_keys, p), $calcit.nth(child_keys, q))) { console.error($calcit.printable("duplicated key", $calcit.nth(child_keys, p)));
ret_AUTO_2 =true
 }
 else if ($calcit._$n__LT_(q, last_pos)) { ret_AUTO_2 =$calcit.recur(p, $calcit.inc(q)) } else { let p_next = $calcit.inc(p);

if ($calcit._$n__LT_(p_next, last_pos)) { ret_AUTO_2 =$calcit.recur(p_next, $calcit.inc(p_next)) } else { ret_AUTO_2 =false }
 }

    if (ret_AUTO_2 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_2.args.length !== 2) throw _calcit_args_mismatch('f%', 2, ret_AUTO_2.args.length);
      [ p, q ] = ret_AUTO_2.args;
      
      times_AUTO_3 += 1;
      continue;
    } else {
      return ret_AUTO_2;
    }
  }
}

(0, 1) } else { return  null; }

}
export let find_props_diffs = function find_props_diffs(collect_$x_, coord, n_coord, old_props, new_props) {
  
if (arguments.length !== 5) throw _calcit_args_mismatch('find-props-diffs', 5, arguments.length);
  
  let times_AUTO_6 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_5 = null;
    if (times_AUTO_6 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    let was_empty_$q_ = $calcit.empty_$q_(old_props);
let now_empty_$q_ = $calcit.empty_$q_(new_props);

if (( was_empty_$q_ ? ( now_empty_$q_ ? now_empty_$q_ : false ) : false )) { ret_AUTO_5 =null }
 else if (( was_empty_$q_ ? (function __fn__(){
let v1__5 = $calcit.not(now_empty_$q_);

if (v1__5) { return v1__5 } else { return false }

})() : false )) { collect_$x_($calcit._$o__$o_(_tag["add-prop"], coord, n_coord, $calcit.first(new_props)));
ret_AUTO_5 =$calcit.recur(collect_$x_, coord, n_coord, old_props, $calcit.rest(new_props))
 }
 else if (( $calcit.not(was_empty_$q_) ? ( now_empty_$q_ ? now_empty_$q_ : false ) : false )) { collect_$x_($calcit._$o__$o_(_tag["rm-prop"], coord, n_coord, $calcit.first($calcit.first(old_props))));
ret_AUTO_5 =$calcit.recur(collect_$x_, coord, n_coord, $calcit.rest(old_props), new_props)
 } else { let old_pair = $calcit.first(old_props);
let new_pair = $calcit.first(new_props);
let old_k = $calcit.first(old_pair);
let old_v = $calcit.last(old_pair);
let new_k = $calcit.first(new_pair);
let new_v = $calcit.last(new_pair);
let old_follows = $calcit.rest(old_props);
let new_follows = $calcit.rest(new_props);
let v__6 = $calcit._$n_compare(old_k, new_k);

if ($calcit._$n__$e_(v__6, -1)) { collect_$x_($calcit._$o__$o_(_tag["rm-prop"], coord, n_coord, old_k));
ret_AUTO_5 =$calcit.recur(collect_$x_, coord, n_coord, old_follows, new_props)
 }
 else if ($calcit._$n__$e_(v__6, 1)) { collect_$x_($calcit._$o__$o_(_tag["add-prop"], coord, n_coord, new_pair));
ret_AUTO_5 =$calcit.recur(collect_$x_, coord, n_coord, old_props, new_follows)
 }
 else if ($calcit._$n__$e_(v__6, 0)) { ( $calcit.not_$e_(old_v, new_v) ? collect_$x_($calcit._$o__$o_(_tag["replace-prop"], coord, n_coord, new_pair)) : null );
ret_AUTO_5 =$calcit.recur(collect_$x_, coord, n_coord, old_follows, new_follows)
 } else { console.log($calcit.printable("[Respo] unknown result")) }
 }


    if (ret_AUTO_5 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_5.args.length !== 5) throw _calcit_args_mismatch('find-props-diffs', 5, ret_AUTO_5.args.length);
      [ collect_$x_, coord, n_coord, old_props, new_props ] = ret_AUTO_5.args;
      
      times_AUTO_6 += 1;
      continue;
    } else {
      return ret_AUTO_5;
    }
  }
}

export let find_style_diffs = function find_style_diffs(collect_$x_, c_coord, coord, old_style, new_style) {
  
if (arguments.length !== 5) throw _calcit_args_mismatch('find-style-diffs', 5, arguments.length);
  
  let times_AUTO_9 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_8 = null;
    if (times_AUTO_9 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    let was_empty_$q_ = $calcit.empty_$q_(old_style);
let now_empty_$q_ = $calcit.empty_$q_(new_style);

if ($calcit.identical_$q_(old_style, new_style)) { ret_AUTO_8 =null }
 else if (( was_empty_$q_ ? ( now_empty_$q_ ? now_empty_$q_ : false ) : false )) { ret_AUTO_8 =null }
 else if (( was_empty_$q_ ? (function __fn__(){
let v1__7 = $calcit.not(now_empty_$q_);

if (v1__7) { return v1__7 } else { return false }

})() : false )) { let entry = $calcit.first(new_style);
let follows = $calcit.rest(new_style);
collect_$x_($calcit._$o__$o_(_tag["add-style"], c_coord, coord, entry));
ret_AUTO_8 =$calcit.recur(collect_$x_, c_coord, coord, old_style, follows)
 }
 else if (( $calcit.not(was_empty_$q_) ? ( now_empty_$q_ ? now_empty_$q_ : false ) : false )) { let entry = $calcit.first(old_style);
let follows = $calcit.rest(old_style);
collect_$x_($calcit._$o__$o_(_tag["rm-style"], c_coord, coord, $calcit.first(entry)));
ret_AUTO_8 =$calcit.recur(collect_$x_, c_coord, coord, follows, new_style)
 } else { let old_entry = $calcit.first(old_style);
let new_entry = $calcit.first(new_style);
let old_follows = $calcit.rest(old_style);
let new_follows = $calcit.rest(new_style);
let v__8 = $calcit._$n_compare($calcit.first(old_entry), $calcit.first(new_entry));

if ($calcit._$n__$e_(v__8, -1)) { collect_$x_($calcit._$o__$o_(_tag["rm-style"], c_coord, coord, $calcit.first(old_entry)));
ret_AUTO_8 =$calcit.recur(collect_$x_, c_coord, coord, old_follows, new_style)
 }
 else if ($calcit._$n__$e_(v__8, 1)) { collect_$x_($calcit._$o__$o_(_tag["add-style"], c_coord, coord, new_entry));
ret_AUTO_8 =$calcit.recur(collect_$x_, c_coord, coord, old_style, new_follows)
 }
 else if ($calcit._$n__$e_(v__8, 0)) { ( $calcit.not($calcit.identical_$q_($calcit.last(old_entry), $calcit.last(new_entry))) ? collect_$x_($calcit._$o__$o_(_tag["replace-style"], c_coord, coord, new_entry)) : null );
ret_AUTO_8 =$calcit.recur(collect_$x_, c_coord, coord, old_follows, new_follows)
 } else { console.log($calcit.printable("[Respo] unknown compare result for style keys")) }
 }


    if (ret_AUTO_8 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_8.args.length !== 5) throw _calcit_args_mismatch('find-style-diffs', 5, ret_AUTO_8.args.length);
      [ collect_$x_, c_coord, coord, old_style, new_style ] = ret_AUTO_8.args;
      
      times_AUTO_9 += 1;
      continue;
    } else {
      return ret_AUTO_8;
    }
  }
}

export let find_element_diffs = function find_element_diffs(collect_$x_, coord, n_coord, old_tree, new_tree) {
  
if (arguments.length !== 5) throw _calcit_args_mismatch('find-element-diffs', 5, arguments.length);
  
  let times_AUTO_12 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_11 = null;
    if (times_AUTO_12 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit.identical_$q_(old_tree, new_tree)) { ret_AUTO_11 =null }
 else if (( component_$q_(old_tree) ? (function __fn__(){
let v1__1 = component_$q_(new_tree);

if (v1__1) { return v1__1 } else { return false }

})() : false )) { let next_coord = $calcit.conj(coord, $calcit._$n_record_$o_get(new_tree, _tag["name"]));

if ($calcit._$e_($calcit._$n_record_$o_get(old_tree, _tag["name"]), $calcit._$n_record_$o_get(new_tree, _tag["name"]))) { collect_updating(collect_$x_, _tag["before-update"], coord, n_coord, old_tree, new_tree);
find_element_diffs(collect_$x_, next_coord, n_coord, $calcit.get(old_tree, _tag["tree"]), $calcit.get(new_tree, _tag["tree"]));
ret_AUTO_11 =collect_updating(collect_$x_, _tag["update"], coord, n_coord, old_tree, new_tree)
 } else { collect_unmounting(collect_$x_, coord, n_coord, old_tree, true);
find_element_diffs(collect_$x_, next_coord, n_coord, $calcit.get(old_tree, _tag["tree"]), $calcit.get(new_tree, _tag["tree"]));
ret_AUTO_11 =collect_mounting(collect_$x_, coord, n_coord, new_tree, true)
 }
 }
 else if (( component_$q_(old_tree) ? (function __fn__(){
let v1__2 = element_$q_(new_tree);

if (v1__2) { return v1__2 } else { return false }

})() : false )) { collect_unmounting(collect_$x_, $calcit.conj(coord, $calcit._$n_record_$o_get(old_tree, _tag["name"])), n_coord, old_tree, true);
ret_AUTO_11 =$calcit.recur(collect_$x_, coord, n_coord, $calcit.get(old_tree, _tag["tree"]), new_tree)
 }
 else if (( element_$q_(old_tree) ? (function __fn__(){
let v1__3 = component_$q_(new_tree);

if (v1__3) { return v1__3 } else { return false }

})() : false )) { let new_coord = $calcit.conj(coord, $calcit._$n_record_$o_get(new_tree, _tag["name"]));
find_element_diffs(collect_$x_, new_coord, n_coord, old_tree, $calcit.get(new_tree, _tag["tree"]));
ret_AUTO_11 =collect_mounting(collect_$x_, coord, n_coord, new_tree, true)

 }
 else if (( element_$q_(old_tree) ? (function __fn__(){
let v1__4 = element_$q_(new_tree);

if (v1__4) { return v1__4 } else { return false }

})() : false )) { 
if ($calcit.not_$e_($calcit._$n_record_$o_get(old_tree, _tag["name"]), $calcit._$n_record_$o_get(new_tree, _tag["name"]))) { collect_$x_($calcit._$o__$o_(_tag["replace-element"], coord, n_coord, new_tree));
ret_AUTO_11 =null
 } else { find_props_diffs(collect_$x_, coord, n_coord, $calcit._$n_record_$o_get(old_tree, _tag["attrs"]), $calcit._$n_record_$o_get(new_tree, _tag["attrs"]));
(function __fn__(){
let old_style = $calcit._$n_record_$o_get(old_tree, _tag["style"]);
let new_style = $calcit._$n_record_$o_get(new_tree, _tag["style"]);

if ($calcit.not_$e_(old_style, new_style)) { return find_style_diffs(collect_$x_, coord, n_coord, old_style, new_style) } else { return  null; }

})();
(function __fn__(){
let old_events = $calcit.keys_non_nil((function __fn__(){
let v1__9 = $calcit._$n_record_$o_get(old_tree, _tag["event"]);

if ($calcit.nil_$q_(v1__9)) { return $calcit._$n__$M_() } else { return v1__9 }

})());
let new_events = $calcit.keys_non_nil((function __fn__(){
let v1__10 = $calcit._$n_record_$o_get(new_tree, _tag["event"]);

if ($calcit.nil_$q_(v1__10)) { return $calcit._$n__$M_() } else { return v1__10 }

})());

if ($calcit.not_$e_(old_events, new_events)) { let added_events = $calcit.difference(new_events, old_events);
let removed_events = $calcit.difference(old_events, new_events);
$calcit.foldl(added_events, null, function doseq_fn_PCT_(_acc, event_name) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
return collect_$x_($calcit._$o__$o_(_tag["set-event"], coord, n_coord, event_name))
}
);
return $calcit.foldl(removed_events, null, function doseq_fn_PCT_(_acc, event_name) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
return collect_$x_($calcit._$o__$o_(_tag["rm-event"], coord, n_coord, event_name))
}
)
 } else { return  null; }

})();
let old_children = $calcit._$n_record_$o_get(old_tree, _tag["children"]);
let new_children = $calcit._$n_record_$o_get(new_tree, _tag["children"]);
( dev_$q_ ? ( detect_keys_dup($calcit.map(new_children, $calcit.first)) ? console.error("Parent that has dups", new_tree) : null ) : null );
ret_AUTO_11 =find_children_diffs(collect_$x_, coord, n_coord, 0, old_children, new_children)

 } } else { ret_AUTO_11 =console.warn("Diffing unknown params", old_tree, new_tree) }

    if (ret_AUTO_11 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_11.args.length !== 5) throw _calcit_args_mismatch('find-element-diffs', 5, ret_AUTO_11.args.length);
      [ collect_$x_, coord, n_coord, old_tree, new_tree ] = ret_AUTO_11.args;
      
      times_AUTO_12 += 1;
      continue;
    } else {
      return ret_AUTO_11;
    }
  }
}

export let find_children_diffs = function find_children_diffs(collect_$x_, coord, n_coord, index, old_children, new_children) {
  
if (arguments.length !== 6) throw _calcit_args_mismatch('find-children-diffs', 6, arguments.length);
  
  let times_AUTO_15 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_14 = null;
    if (times_AUTO_15 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    let was_empty_$q_ = $calcit.empty_$q_(old_children);
let now_empty_$q_ = $calcit.empty_$q_(new_children);

if (( was_empty_$q_ ? ( now_empty_$q_ ? now_empty_$q_ : false ) : false )) { ret_AUTO_14 =null }
 else if (( was_empty_$q_ ? (function __fn__(){
let v1__11 = $calcit.not(now_empty_$q_);

if (v1__11) { return v1__11 } else { return false }

})() : false )) { let pair = $calcit.first(new_children);
let k = $calcit.first(pair);
let element = $calcit.last(pair);
let new_coord = $calcit.conj(coord, k);
collect_$x_($calcit._$o__$o_(_tag["append-element"], new_coord, n_coord, element));
collect_mounting(collect_$x_, coord, $calcit.conj(n_coord, index), element, true);
ret_AUTO_14 =$calcit.recur(collect_$x_, coord, n_coord, $calcit.inc(index), $calcit._$L_(), $calcit.rest(new_children))
 }
 else if (( $calcit.not(was_empty_$q_) ? ( now_empty_$q_ ? now_empty_$q_ : false ) : false )) { let pair = $calcit.first(old_children);
let k = $calcit.first(pair);
let new_coord = $calcit.conj(coord, k);
let new_n_coord = $calcit.conj(n_coord, index);
collect_unmounting(collect_$x_, coord, new_n_coord, $calcit.last(pair), true);
collect_$x_($calcit._$o__$o_(_tag["rm-element"], new_coord, new_n_coord, null));
ret_AUTO_14 =$calcit.recur(collect_$x_, coord, n_coord, index, $calcit.rest(old_children), $calcit._$L_())
 } else { let old_keys = $calcit.map($calcit.take(old_children, 16), $calcit.first);
let new_keys = $calcit.map($calcit.take(new_children, 16), $calcit.first);
let x1 = $calcit.first(old_keys);
let y1 = $calcit.first(new_keys);
let match_x1 = function f_PCT_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit._$e_(x, x1)
}
;
let match_y1 = function f_PCT_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit._$e_(x, y1)
}
;
let x1_remains_$q_ = $calcit.any_$q_(new_keys, match_x1);
let y1_existed_$q_ = $calcit.any_$q_(old_keys, match_y1);
let old_follows = $calcit.rest(old_children);
let new_follows = $calcit.rest(new_children);
( $calcit.nil_$q_(y1) ? console.warn("nil key is bad in Respo") : null );

if ($calcit._$e_(x1, y1)) { let old_element = val_of_first(old_children);
let new_element = val_of_first(new_children);
find_element_diffs(collect_$x_, $calcit.conj(coord, x1), $calcit.conj(n_coord, index), old_element, new_element);
ret_AUTO_14 =$calcit.recur(collect_$x_, coord, n_coord, $calcit.inc(index), old_follows, new_follows)
 }
 else if (( x1_remains_$q_ ? (function __fn__(){
let v1__12 = $calcit.not(y1_existed_$q_);

if (v1__12) { return v1__12 } else { return false }

})() : false )) { let pair = $calcit.first(new_children);
let k = $calcit.first(pair);
let element = $calcit.last(pair);
let new_coord = $calcit.conj(coord, k);
let new_n_coord = $calcit.conj(n_coord, index);
collect_$x_($calcit._$o__$o_(_tag["add-element"], new_coord, new_n_coord, element));
collect_mounting(collect_$x_, coord, new_n_coord, val_of_first(new_children), true);
ret_AUTO_14 =$calcit.recur(collect_$x_, coord, n_coord, $calcit.inc(index), old_children, new_follows)
 }
 else if (( $calcit.not(x1_remains_$q_) ? ( y1_existed_$q_ ? y1_existed_$q_ : false ) : false )) { let pair = $calcit.first(old_children);
let k = $calcit.first(pair);
let new_coord = $calcit.conj(coord, k);
let new_n_coord = $calcit.conj(n_coord, index);
collect_unmounting(collect_$x_, coord, new_n_coord, $calcit.last(pair), true);
collect_$x_($calcit._$o__$o_(_tag["rm-element"], new_coord, new_n_coord, null));
ret_AUTO_14 =$calcit.recur(collect_$x_, coord, n_coord, index, old_follows, new_children)
 } else { let xi = $calcit.index_of(new_keys, x1);
let yi = $calcit.index_of(old_keys, y1);
let first_old_entry = $calcit.first(old_children);
let first_new_entry = $calcit.first(new_children);
let new_n_coord = $calcit.conj(n_coord, index);

if ($calcit._LT__$e_(xi, yi)) { let new_element = val_of_first(new_children);
let new_coord = $calcit.conj(coord, y1);
collect_$x_($calcit._$o__$o_(_tag["add-element"], new_coord, new_n_coord, new_element));
collect_mounting(collect_$x_, coord, new_n_coord, new_element, true);
ret_AUTO_14 =$calcit.recur(collect_$x_, coord, n_coord, $calcit.inc(index), old_children, new_follows)
 } else { collect_unmounting(collect_$x_, coord, new_n_coord, val_of_first(old_children), true);
collect_$x_($calcit._$o__$o_(_tag["rm-element"], $calcit.conj(coord, x1), new_n_coord, null));
ret_AUTO_14 =$calcit.recur(collect_$x_, coord, n_coord, index, old_follows, new_children)
 }
 }
 }


    if (ret_AUTO_14 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_14.args.length !== 6) throw _calcit_args_mismatch('find-children-diffs', 6, ret_AUTO_14.args.length);
      [ collect_$x_, coord, n_coord, index, old_children, new_children ] = ret_AUTO_14.args;
      
      times_AUTO_15 += 1;
      continue;
    } else {
      return ret_AUTO_14;
    }
  }
}




