
import * as $calcit from "./calcit.core.mjs";
import { component_$q_ } from "./respo.util.detect.mjs";
import { dashed__GT_camel } from "./respo.util.format.mjs";
import { event__GT_prop } from "./respo.util.format.mjs";
import { get_style_value } from "./respo.util.format.mjs";
var _tag={};
["attrs","children","event","name","style","tree",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function make_element(virtual_element, listener_builder, coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('make-element', 3, arguments.length);
(function __fn__(){
( $calcit.not($calcit.string_$q_("coord is required")) ? (function __fn__(){
let err_AUTO_1 = new Error($calcit.str_spaced("expects 1st argument to be string, got:", "coord is required"));
 err_AUTO_1.data = null;
 throw err_AUTO_1;
})() : null );

if ($calcit.some_$q_(coord)) { return null } else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("some?"), new $calcit.CalcitSymbol("coord")]))));
let err_AUTO_2 = new Error("coord is required (some? coord)");
 err_AUTO_2.data = null;
 throw err_AUTO_2;
 }

})();

if (component_$q_(virtual_element)) { return make_element($calcit._$n_record_$o_get(virtual_element, _tag["tree"]), listener_builder, $calcit.conj(coord, $calcit._$n_record_$o_get(virtual_element, _tag["name"]))) } else { let tag_name = $calcit.turn_string($calcit._$n_record_$o_get(virtual_element, _tag["name"]));
let attrs = $calcit._$n_record_$o_get(virtual_element, _tag["attrs"]);
let style = $calcit._$n_record_$o_get(virtual_element, _tag["style"]);
let children = $calcit._$n_record_$o_get(virtual_element, _tag["children"]);
let element = document.createElement(tag_name);
let child_elements = $calcit.map(children, function f_PCT_(pair) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
(function __fn__(){
( $calcit.not($calcit.string_$q_("expect pair of key/element")) ? (function __fn__(){
let err_AUTO_3 = new Error($calcit.str_spaced("expects 1st argument to be string, got:", "expect pair of key/element"));
 err_AUTO_3.data = null;
 throw err_AUTO_3;
})() : null );

if (( $calcit.list_$q_(pair) ? (function __fn__(){
let v1__1 = $calcit._$n__$e_(2, $calcit.count(pair));

if (v1__1) { return v1__1 } else { return false }

})() : false )) { return null } else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("and"), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("list?"), new $calcit.CalcitSymbol("pair")]), new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("&="), 2, new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("count"), new $calcit.CalcitSymbol("pair")])])]))));
let err_AUTO_4 = new Error("expect pair of key/element (and (list? pair) (&= 2 (count pair)))");
 err_AUTO_4.data = null;
 throw err_AUTO_4;
 }

})();
let k = $calcit._$n_list_$o_nth(pair, 0);
let child = $calcit._$n_list_$o_nth(pair, 1);
( $calcit.nil_$q_(k) ? console.warn("nil key is bad for Respo") : null );

if ($calcit.some_$q_(child)) { return make_element(child, listener_builder, $calcit.conj(coord, k)) } else { return  null; }

}
);
$calcit.foldl(attrs, null, function doseq_fn_PCT_(_acc, entry) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
let k = dashed__GT_camel($calcit.turn_string($calcit.first(entry)));
let v = $calcit.last(entry);

if ($calcit.some_$q_(v)) { return $calcit.aset(element, k, v) } else { return  null; }

}
);
$calcit.foldl(style, null, function doseq_fn_PCT_(_acc, entry) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
let style_name = $calcit.turn_string($calcit.first(entry));
let k = dashed__GT_camel(style_name);
let v = $calcit.last(entry);
return $calcit.aset(element.style, k, get_style_value(v, k))

}
);
$calcit.foldl($calcit._$n_record_$o_get(virtual_element, _tag["event"]), null, function doseq_fn_PCT_(_acc, entry) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
let event_name = $calcit.first(entry);
let name_in_string = event__GT_prop(event_name);
return $calcit.aset(element, name_in_string, function f_PCT_(event) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
listener_builder(event_name)(event, coord);
return event.stopPropagation()
}
)

}
);
$calcit.foldl(child_elements, null, function doseq_fn_PCT_(_acc, child_element) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);

if ($calcit.some_$q_(child_element)) { return element.appendChild(child_element) } else { return  null; }
}
);
return element
 }
}
export function style__GT_string(styles) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('style->string', 1, arguments.length);
return function f_PCT_(acc, xs) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
  
  let times_AUTO_7 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_6 = null;
    if (times_AUTO_7 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit.empty_$q_(xs)) { ret_AUTO_6 =acc } else { let entry = $calcit.first(xs);
let k = $calcit.first(entry);
let style_name = $calcit.turn_string(k);
let v = get_style_value($calcit.last(entry), style_name);
ret_AUTO_6 =$calcit.recur($calcit.str(acc, style_name, ":", v, ";"), $calcit.rest(xs))
 }

    if (ret_AUTO_6 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_6.args.length !== 2) throw _calcit_args_mismatch('f%', 2, ret_AUTO_6.args.length);
      [ acc, xs ] = ret_AUTO_6.args;
      
      times_AUTO_7 += 1;
      continue;
    } else {
      return ret_AUTO_6;
    }
  }
}

("", styles)
}



