
import * as $calcit from "./calcit.core.mjs";
import { dashed__GT_camel } from "./respo.util.format.mjs";
import { event__GT_prop } from "./respo.util.format.mjs";
import { get_style_value } from "./respo.util.format.mjs";
import { make_element } from "./respo.render.dom.mjs";
import { style__GT_string } from "./respo.render.dom.mjs";
var _tag={};
["add-element","add-prop","add-style","append-element","checked","class-name","disabled","effect-before-update","effect-mount","effect-unmount","effect-update","href","inner-text","innerHTML","replace-element","replace-prop","replace-style","rm-element","rm-event","rm-prop","rm-style","selected","set-event",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function add_element(target, op, listener_builder, coord) { 
if (arguments.length !== 4) throw _calcit_args_mismatch('add-element', 4, arguments.length);
let new_element = make_element(op, listener_builder, coord);
return target.parentElement.insertBefore(new_element, target)

}
export function add_event(target, event_name, listener_builder, coord) { 
if (arguments.length !== 4) throw _calcit_args_mismatch('add-event', 4, arguments.length);
let event_prop = event__GT_prop(event_name);
return $calcit.aset(target, event_prop, function f_PCT_(event) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
listener_builder(event_name)(event, coord);
return event.stopPropagation()
}
)

}
export function add_prop(target, op) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('add-prop', 2, arguments.length);
let p = $calcit._$n_list_$o_nth(op, 0);
let prop_value = $calcit._$n_list_$o_nth(op, 1);
let prop_name = dashed__GT_camel($calcit.turn_string(p));
let v__2 = prop_name;

if ($calcit._$n__$e_(v__2, "style")) { return $calcit.aset(target, prop_name, style__GT_string(prop_value)) } else { return $calcit.aset(target, prop_name, prop_value) }

}
export function add_style(target, op) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('add-style', 2, arguments.length);
let p = $calcit._$n_list_$o_nth(op, 0);
let v = $calcit._$n_list_$o_nth(op, 1);
let style_name = dashed__GT_camel($calcit.turn_string(p));
let style_value = get_style_value(v, style_name);
return $calcit.aset(target.style, style_name, style_value)

}
export function append_element(target, op, listener_builder, coord) { 
if (arguments.length !== 4) throw _calcit_args_mismatch('append-element', 4, arguments.length);
let new_element = make_element(op, listener_builder, coord);
return target.appendChild(new_element)

}
export let find_target = function find_target(root, coord) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('find-target', 2, arguments.length);
  
  let times_AUTO_3 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_2 = null;
    if (times_AUTO_3 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit.empty_$q_(coord)) { ret_AUTO_2 =root } else { let index = $calcit.first(coord);
let child = $calcit.aget(root.children, index);

if ($calcit.some_$q_(child)) { ret_AUTO_2 =$calcit.recur(child, $calcit.rest(coord)) } else { ret_AUTO_2 =null }
 }

    if (ret_AUTO_2 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_2.args.length !== 2) throw _calcit_args_mismatch('find-target', 2, ret_AUTO_2.args.length);
      [ root, coord ] = ret_AUTO_2.args;
      
      times_AUTO_3 += 1;
      continue;
    } else {
      return ret_AUTO_2;
    }
  }
}

export function replace_element(target, op, listener_builder, coord) { 
if (arguments.length !== 4) throw _calcit_args_mismatch('replace-element', 4, arguments.length);
let new_element = make_element(op, listener_builder, coord);
target.parentElement.insertBefore(new_element, target);
return target.remove()

}
export function replace_prop(target, op) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('replace-prop', 2, arguments.length);
let p = $calcit._$n_list_$o_nth(op, 0);
let prop_value = $calcit._$n_list_$o_nth(op, 1);
let prop_name = dashed__GT_camel($calcit.turn_string(p));

if ($calcit.identical_$q_(prop_name, "value")) { 
if ($calcit.not_$e_(prop_value, target.value)) { return $calcit.aset(target, prop_name, prop_value) } else { return  null; } } else { return $calcit.aset(target, prop_name, prop_value) }

}
export function replace_style(target, op) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('replace-style', 2, arguments.length);
let p = $calcit._$n_list_$o_nth(op, 0);
let v = $calcit._$n_list_$o_nth(op, 1);
let style_name = dashed__GT_camel($calcit.turn_string(p));
return $calcit.aset(target.style, style_name, get_style_value(v, dashed__GT_camel(style_name)))

}
export function rm_element(target, op) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('rm-element', 2, arguments.length);

if ($calcit.some_$q_(target)) { return target.remove() } else { return console.warn("Respo: Element already removed! Probably by :inner-text.") }
}
export function rm_event(target, event_name) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('rm-event', 2, arguments.length);
let event_prop = event__GT_prop(event_name);
return $calcit.aset(target, event_prop, null)

}
export function rm_prop(target, op) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('rm-prop', 2, arguments.length);
let v__3 = op;

if ($calcit._$n__$e_(v__3, _tag["class-name"])) { return target.removeAttribute("class") }
 else if ($calcit._$n__$e_(v__3, _tag["href"])) { return target.removeAttribute("href") }
 else if ($calcit._$n__$e_(v__3, _tag["inner-text"])) { target.innerText = "" }
 else if ($calcit._$n__$e_(v__3, _tag["innerHTML"])) { target.innerHTML = "" }
 else if ($calcit._$n__$e_(v__3, _tag["checked"])) { target.checked = false }
 else if ($calcit._$n__$e_(v__3, _tag["disabled"])) { target.disabled = false }
 else if ($calcit._$n__$e_(v__3, _tag["selected"])) { target.selected = false } else { let k = dashed__GT_camel($calcit.turn_string(op));
return $calcit.aset(target, k, null)
 }

}
export function rm_style(target, op) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('rm-style', 2, arguments.length);
let style_name = dashed__GT_camel($calcit.turn_string(op));
return $calcit.aset(target.style, style_name, null)

}
export function run_effect(target, method, coord) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('run-effect', 3, arguments.length);

if ($calcit.some_$q_(target)) { return method(target) } else { return console.warn("Unknown effects target:", coord) }
}
export function apply_dom_changes(changes, mount_point, listener_builder) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('apply-dom-changes', 3, arguments.length);
let root = mount_point.firstElementChild;
return $calcit.foldl(changes, null, function doseq_fn_PCT_(_acc, op) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
let n_coord = $calcit.nth(op, 2);
let target = find_target(root, n_coord);
( $calcit.not($calcit.tuple_$q_(op)) ? (function __fn__(){
let err_AUTO_4 = new Error($calcit.str("tag-match expected tuple, got", op));
 err_AUTO_4.data = null;
 throw err_AUTO_4;
})() : null );
let tag__1 = $calcit._$n_tuple_$o_nth(op, 0);

if ($calcit._$n__$e_(tag__1, _tag["replace-prop"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return replace_prop(target, op_data)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["add-prop"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return add_prop(target, op_data)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["rm-prop"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return rm_prop(target, op_data)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["add-style"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return add_style(target, op_data)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["replace-style"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return replace_style(target, op_data)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["rm-style"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return rm_style(target, op_data)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["set-event"])) { let coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return add_event(target, op_data, listener_builder, coord)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["rm-event"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return rm_event(target, op_data)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["add-element"])) { let coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return add_element(target, op_data, listener_builder, coord)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["rm-element"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return rm_element(target, op_data)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["replace-element"])) { let coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return replace_element(target, op_data, listener_builder, coord)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["append-element"])) { let coord = $calcit._$n_tuple_$o_nth(op, 1);
let _n_coord = $calcit._$n_tuple_$o_nth(op, 2);
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return append_element(target, op_data, listener_builder, coord)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["effect-mount"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
return (function __bind__(n_coord){
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return run_effect(target, op_data, n_coord)

 })($calcit._$n_tuple_$o_nth(op, 2))
 }
 else if ($calcit._$n__$e_(tag__1, _tag["effect-unmount"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
return (function __bind__(n_coord){
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return run_effect(target, op_data, n_coord)

 })($calcit._$n_tuple_$o_nth(op, 2))
 }
 else if ($calcit._$n__$e_(tag__1, _tag["effect-update"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
return (function __bind__(n_coord){
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return run_effect(target, op_data, n_coord)

 })($calcit._$n_tuple_$o_nth(op, 2))
 }
 else if ($calcit._$n__$e_(tag__1, _tag["effect-before-update"])) { let _coord = $calcit._$n_tuple_$o_nth(op, 1);
return (function __bind__(n_coord){
let op_data = $calcit._$n_tuple_$o_nth(op, 3);
return run_effect(target, op_data, n_coord)

 })($calcit._$n_tuple_$o_nth(op, 2))
 } else { console.error($calcit.printable("not implemented:", op)) }



}
)

}



