
import * as $calcit from "./calcit.core.mjs";
var _tag={};
["alt?","change","checked","click","code","ctrl?","event","focus","input","key","key-code","keycode","keydown","keypress","keyup","meta?","msg","original-event","shift?","type","value",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function dashed__GT_camel(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('dashed->camel', 1, arguments.length);
return x.replace(dashed_letter_pattern, function f_PCT_(cc, pos, prop) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('f%', 3, arguments.length);
return $calcit.aget(cc, 1).toUpperCase()
}
)
}
export function map_keyboard_event(event) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('map-keyboard-event', 1, arguments.length);
return $calcit._$n__$M_(_tag["key"], event.key, _tag["code"], event.code, _tag["ctrl?"], event.ctrlKey, _tag["meta?"], event.metaKey, _tag["alt?"], event.altKey, _tag["shift?"], event.shiftKey)
}
export function event__GT_edn(event) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('event->edn', 1, arguments.length);
return $calcit.assoc($calcit.assoc((function __fn__(){
let v__1 = event.type;

if ($calcit._$n__$e_(v__1, "click")) { return $calcit._$n__$M_(_tag["type"], _tag["click"]) }
 else if ($calcit._$n__$e_(v__1, "keydown")) { return $calcit.merge(map_keyboard_event(event), $calcit._$n__$M_(_tag["type"], _tag["keydown"], _tag["key-code"], event.keyCode, _tag["keycode"], event.keyCode)) }
 else if ($calcit._$n__$e_(v__1, "keypress")) { return $calcit.merge(map_keyboard_event(event), $calcit._$n__$M_(_tag["type"], _tag["keypress"])) }
 else if ($calcit._$n__$e_(v__1, "keyup")) { return $calcit.merge(map_keyboard_event(event), $calcit._$n__$M_(_tag["type"], _tag["keyup"])) }
 else if ($calcit._$n__$e_(v__1, "input")) { return $calcit._$n__$M_(_tag["type"], _tag["input"], _tag["value"], $calcit.aget(event.target, "value"), _tag["checked"], event.target.checked) }
 else if ($calcit._$n__$e_(v__1, "change")) { return $calcit._$n__$M_(_tag["type"], _tag["change"], _tag["value"], $calcit.aget(event.target, "value")) }
 else if ($calcit._$n__$e_(v__1, "focus")) { return $calcit._$n__$M_(_tag["type"], _tag["focus"]) } else { return $calcit._$n__$M_(_tag["type"], event.type, _tag["msg"], $calcit.str("Unhandled event: ", event.type)) }

})(), _tag["original-event"], event), _tag["event"], event)
}
export function event__GT_prop(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('event->prop', 1, arguments.length);
return $calcit.str("on", $calcit.turn_string(x))
}
export function get_style_value(x, prop) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('get-style-value', 2, arguments.length);

if ($calcit.string_$q_(x)) { return x }
 else if ($calcit.tag_$q_(x)) { return $calcit.turn_string(x) }
 else if ($calcit.number_$q_(x)) { 
if (pattern_non_dimension_props.test(prop)) { return $calcit.str(x) } else { return $calcit.str(x, "px") } } else { return $calcit.str(x) }
}
export function hsl(h, s, l, arg) { 
if (arguments.length < 3) throw new Error('too few arguments');
if (arguments.length > 4) throw new Error('too many arguments');
let a = ( $calcit.nil_$q_(arg) ? 1 : arg );
return $calcit.str("hsl(", h, ",", s, "%,", l, "%,", a, ")")

}



export var dashed_letter_pattern = new RegExp("-[a-z]", "g");

export var pattern_non_dimension_props = new RegExp("acit|ex(?:s|g|n|p|$)|rph|grid|ows|mnc|ntw|ine[ch]|zoo|^ord|itera", "i");

